/*
 * Subverse
 * Copyright (C) 2007 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include <allegro.h>
#include "Config.h"
#include "World.h"

int timer;

void increase_timer(void) {
      timer++;
}
END_OF_FUNCTION(increase_timer);

int main (int argv, char* argc[]){
	allegro_init();
	install_keyboard();
	install_timer();
	install_mouse();
	if (install_sound(SOUND_CARD, MIDI_CARD, NULL) != 0 ) {
        cerr << "ERROR: " << allegro_error << endl;;
    }
	//install_sound(SOUND_CARD, MIDI_CARD, NULL);
	set_color_depth(16);
	set_volume(128, 255);

	int vmode = VMODE;
	if (argv > 1) {
		if (strcmp(argc[1], "full") == 0) {
			vmode = VMODE_FULL;
		}
	}
	set_gfx_mode(vmode, MAX_X, MAX_Y, 0, 0);

	timer = 0;
	LOCK_VARIABLE(timer);
	LOCK_FUNCTION(increase_timer);
	install_int(increase_timer, 1000);

	World *world = new World("subverse.map");
	world->run();
	delete world;
	stop_midi();
	remove_int(increase_timer);
	remove_timer();
	fade_out(4);
	allegro_exit();
	return 0;
}
END_OF_MAIN();
