/*
 * Subverse
 * Copyright (C) 2007 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include "Spider.h"
#include "World.h"
#include <stdlib.h>

Spider::Spider(World* w) :
	Element(w, "spider", SPIDER)
{
    setCreature(true);
}

void Spider::execute() {
	Vision *vision = getVision();
	bool found = false;
	Element* e =  NULL;
	do {
        e = vision->getNext(ELEMENT);
		if (e != NULL) {
            if (getHelth() < 20) {
                if ((e->getType() == TREE) && (e->getFood() > 0)) {
                    found = true;
                } else if ((e->isCreature()) && (!e->isAlive()) && (e->getFood() > 0)) {
                	found = true;
                }
            } else if (isUnderAttack() && (e == getAttacker()) && e->isAlive()) {
            	found = true;
			} else if ((e->getType() == CYCLOPE) && e->isCreature() && e->isAlive()) {
				found = true;
            }
		}
    } while ((!found) && (e != NULL));
	if (found) {
		Element* front = getAround(ELEMENT, FRONT);
		if (front != NULL) {
            if ((front->getType() != SPIDER) && (front->isCreature())) {
                attack(e);
            } else if ((e->getType() == TREE) && (e->getFood() > 0)) {
                eat(e);
            } else if ((e->isCreature()) && (!e->isAlive()) && (e->getFood() > 0)) {
            	eat(e);
            }
        } else {
			if (e->getX() > getX()) move(RIGHT);
			else if (e->getX() < getX()) move(LEFT);
			else if (e->getY() > getY()) move(DOWN);
			else if (e->getY() < getY()) move(UP);
        }
    } else {
        int dir = getDirection();
        if (!move(dir)) {
			switch (dir) {
				case UP         : setDirection(LEFT); break;
				case LEFT       : setDirection(DOWN); break;
				case DOWN       : setDirection(RIGHT); break;
				case RIGHT      : setDirection(UP); break;
			}
        }
	}
}

Spider::~Spider() {
}
