/*
 * Subverse
 * Copyright (C) 2009 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include "Timer.h"

Timer::Timer() {
	reset();
}

void Timer::reset() {
	year = 0;
	month = 0;
	day = 0;
	hour = 0;
	minute = 0;
	secound = 0;
}

void Timer::inc() {
	secound++;
	if (secound > 60) {
		secound = 0;
		minute++;
		if (minute > 60) {
			minute = 0;
			hour++;
			if (hour > 24) {
				hour = 0;
				day++;
				if (day > 30) {
					day = 1;
					month++;
					if (month > 12) {
						month = 1;
						year++;
					}
				}
			}
		}
	}
}

string Timer::toString() {
	string out = intToString(year);
	out += intToString(month);
	out += intToString(day);
	out += intToString(hour);
	out += intToString(minute);
	out += intToString(secound);
	return out;
}

long Timer::valueOf() {
	long out = secound;
	out += minute * 60;
	out += hour * 60 * 60;
	out += day * 60 * 60 * 24;
	out += month * 60 * 60 * 24 * 30;
	out += year * 60 * 60 * 24 * 30 * 12;
	return out;
}

void Timer::setYear(int y) {
	if (y < 1) year = 1;
	else year = y;
}

void Timer::setMonth(int m) {
	if (m < 1) month = 1;
	else if (m > 12) month = 12;
	else month = m;
}

void Timer::setDay(int d) {
	if (d < 1) day = 1;
	else if (d > 30) day = 30;
	else day = d;
}

void Timer::setHour(int h) {
	if (h < 0) hour = 0;
	else if (h > 24) hour = 24;
	else hour = h;
}

void Timer::setMinute(int m) {
	if (m < 0) minute = 0;
	else if (m > 60) minute = 60;
	else minute = m;
}

void Timer::setSecound(int s) {
	if (s < 0) secound = 0;
	else if (s > 60) secound = 60;
	else secound = s;
}

int Timer::getYear() {
	return year;
}

int Timer::getMonth() {
	return month;
}

int Timer::getDay() {
	return day;
}

int Timer::getHour() {
	return hour;
}

int Timer::getMinute() {
	return minute;
}

int Timer::getSecound() {
	return secound;
}

Timer::~Timer() {
}
