/*
 * Subverse
 * Copyright (C) 2009 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include "Vision.h"

Vision::Vision() {
    indexElement = 0;
    indexLand = 0;
}

Element* Vision::getNext(int type) {
    Element* e = NULL;
    if (type == ELEMENT) {
        if (indexElement < element.size()) {
            e = element[indexElement];
            indexElement++;
        }
    } else if (type == LAND) {
        if (indexLand < land.size()) {
            e = land[indexLand];
            indexLand++;
        }
    }
    return e;
}

bool Vision::contains(Element* e, int type) {
    int found = false;
    unsigned int i = 0;
    if (type == ELEMENT) {
        while ((!found) && (i < element.size())) {
            found = (e == element[i]);
            i++;
        }
    } else if (type == LAND) {
        while ((!found) && (i < land.size())) {
            found = (e == land[i]);
            i++;
        }
    }
    return found;
}

void Vision::reset(int type) {
    if (type == ELEMENT) {
        indexElement = 0;
    } else if (type == LAND) {
        indexLand = 0;
    }
}

void Vision::add(Element* e, int type) {
    if (e != NULL) {
        if (type == ELEMENT) {
            element.push_back(e);
        } else if (type == LAND) {
            land.push_back(e);
        }
    }
}

Vision::~Vision() {
}
